<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="text"/>
  <xsl:template match="/datadesigner">
    <xsl:for-each select="entities/entity">
      <xsl:call-template name="doEntity"/>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="doEntity">
CREATE TABLE <xsl:value-of select="@pname"/> (
    <xsl:call-template name="doAttributes"/>
    <xsl:call-template name="doConstraints"/>
);
    <xsl:call-template name="doIndex"><xsl:with-param name="entity"><xsl:value-of select="@pname"/></xsl:with-param></xsl:call-template>
  </xsl:template>

  <xsl:template name="doAttributes">
    <xsl:for-each select="attributes/attribute">
      <xsl:value-of select="@pname"/>
      <xsl:text> </xsl:text>
      <xsl:value-of select="type"/>
      <xsl:if test="length &gt; 0"><xsl:text>(</xsl:text><xsl:value-of select="length"/>
      <xsl:if test="decimals &gt; 0"><xsl:text>, </xsl:text><xsl:value-of select="decimals"/></xsl:if><xsl:text>)</xsl:text></xsl:if>      <xsl:if test="not (position() = last())"><xsl:text>,
    </xsl:text></xsl:if>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="doConstraints">
    <xsl:for-each select="constraints/constraint">
      <xsl:text>,
      </xsl:text>
      <xsl:choose>
        <xsl:when test="type = &quot;primarykey&quot;">
	  <xsl:text>PRIMARY KEY</xsl:text><xsl:call-template name="doSimpleAttrs"/>
	</xsl:when>
        <xsl:when test="type = &quot;foreignkey&quot;">
	  <xsl:text>FOREIGN KEY</xsl:text><xsl:call-template name="doSimpleAttrs"/>
	  <xsl:text> REFERENCES </xsl:text>
	  <xsl:variable name="rel" select="relation"/>
	  <xsl:for-each select="../../../../relations/relation">
	    <xsl:if test="$rel = @name">
	      <xsl:value-of select="parent"/>
	      <xsl:variable name="par" select="parent"/>
	      <xsl:for-each select="../../entities/entity">
	        <xsl:if test="$par = @name">
		  <xsl:for-each select="constraints/constraint">
		    <xsl:if test="type = &quot;primarykey&quot;"><xsl:call-template name="doSimpleAttrs"/></xsl:if>
		  </xsl:for-each>
		</xsl:if>
	      </xsl:for-each>
	    </xsl:if>
	  </xsl:for-each>
	</xsl:when>
        <xsl:when test="type = &quot;unique&quot;">
	  <xsl:text>UNIQUE</xsl:text><xsl:call-template name="doSimpleAttrs"/>
	</xsl:when>
      </xsl:choose>
    </xsl:for-each>
  </xsl:template>
  
  <xsl:template name="doSimpleAttrs">
    <xsl:text> ( </xsl:text>
    <xsl:for-each select="simpleattributes/simpleattribute">
      <xsl:value-of select="@name"/>
      <xsl:if test="not (position() = last())"><xsl:text>, </xsl:text></xsl:if>
    </xsl:for-each>
    <xsl:text> ) </xsl:text>
  </xsl:template>

</xsl:stylesheet>
